The schema contains the following properties:
Property
Type
Description
type
string
Any of 'json', 'csv', 'xml', 'columnJson'.
countPath
string
The data reader uses this to get the data source collection length.
dataPath
string
The data reader uses this to get the data source collection after parse.
columns
GC.Data.IColumnCollection
The columns definitions of the data source table. Its key is column name, and its value is the column information, which contains dataType, dataPattern, dataMap and dataName.
The dataType can be a "string", "number", "boolean", "object", "array", "date", "rowOrder" or "formula". It is the actual data type of original value, and useful for a Date because a Date is a string in JSON data and needs be converted.
The dataPattern is a string for parsing strings to value, such as the formatter "dd/MM/yyyy" for a date string, true and false value pairs, "Yes|No" for a boolean string, and decimal separator "," for a numeric string.
The dataMap is a simple map to display the original value in a more meaningful way. Its key can be a number or string, and its value can be a number, string or Date.
The dataName indicates the name of the original data field that be from data source, using this property can map the original field name to the new field name in the data manager.
This is the sample code of type, dataPath and countPath.
This is the sample code for dataType and dataMap.
This is the sample code for dataPattern.
This is the sample code of dataName. the keys of the property columns indicate the field names in the data manager, and the dataName indicates the original data source field name.
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
window.onload = function() {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 0 });
initSpread(spread);
};
function initSpread(spread) {
spread.suspendPaint();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
//init a data manager
var tableName = "Order";
var baseApiUrl = getBaseApiUrl();
var apiUrl = baseApiUrl + "/" + tableName;
var dataManager = spread.dataManager();
var myTable = dataManager.addTable("myTable", {
remote: {
read: {
url: apiUrl
}
},
schema: {
columns: {
OrderId: {dataName: "Id"},
OrderDate: {dataType: "date"},
RequiredDate: {dataType: "date"},
ShippedDate: {dataType: "date"},
ShipVia: {dataMap: {1: "Speedy Express", 2: "United Package", 3: "Federal Shipping"}}
}
}
});
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
//bind a view to the table sheet
myTable.fetch().then(function() {
var style = { formatter: 'MM/dd/yyyy' };
var style2 = {
formatter: 'Ship To: {{=CONCAT(@."ShipAddress", ", ", @."ShipCity")}}'
};
var view = myTable.addView("myView", [
{ value: "OrderId", width: 60 },
{ value: "CustomerId",caption:"Customer", width: 100 },
{ value: "ShipName", width: 200 },
{ value: "OrderDate", width: 120, style: style },
{ value: "ShippedDate", width: 120, style: style },
{ value: "ShipVia", width: 120 },
{ value: "=[@]",caption:"Ship Address",style:style2, width: 350 },
]);
sheet.setDataView(view);
});
spread.resumePaint();
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Promise Polyfill for IE, https://www.npmjs.com/package/promise-polyfill -->
<script src="https://cdn.jsdelivr.net/npm/promise-polyfill@8/dist/polyfill.min.js"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-tablesheet/dist/gc.spread.sheets.tablesheet.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div id="optionContainer" class="optionContainer">
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
margin: 0;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}

Data Source Schema

SpreadJS TableSheet gives the user the ability to provide a data source schema that defines the structure and properties of the TableSheet being added. The user can also use the data source schema to assign a different dataType for columns or a dataPattern/dataMap on how the data would be presented in the TableSheet.

Description
app.component.ts
index.html
app.component.html
styles.css
Copy to CodeMine

The schema contains the following properties:

Property Type Description
type string Any of 'json', 'csv', 'xml', 'columnJson'.
countPath string The data reader uses this to get the data source collection length.
dataPath string The data reader uses this to get the data source collection after parse.
columns GC.Data.IColumnCollection The columns definitions of the data source table. Its key is column name, and its value is the column information, which contains dataType, dataPattern, dataMap and dataName.

The dataType can be a "string", "number", "boolean", "object", "array", "date", "rowOrder" or "formula". It is the actual data type of original value, and useful for a Date because a Date is a string in JSON data and needs be converted.

The dataPattern is a string for parsing strings to value, such as the formatter "dd/MM/yyyy" for a date string, true and false value pairs, "Yes|No" for a boolean string, and decimal separator "," for a numeric string.

The dataMap is a simple map to display the original value in a more meaningful way. Its key can be a number or string, and its value can be a number, string or Date.

The dataName indicates the name of the original data field that be from data source, using this property can map the original field name to the new field name in the data manager.

interface GC.Data.IColumnCollection {
    [key: string]: GC.Data.IColumn;
}
interface GC.Data.IColumn {
    dataName?: string;
    dataType?: "string" | "number" | "boolean" | "object" | "array" | "date" | "rowOrder" | "formula";
    dataPattern?: string;
    dataMap?: any;
}

This is the sample code of type, dataPath and countPath.

    var myTable = dataManager.addTable("myTable", {
        remote: {
            read: {
                url: 'https://services.odata.org/OData/OData.svc/Products/',
                adapter: 'odata'
            }
        },
        schema: {
            type: 'xml',
            dataPath: 'feed.entry',
            countPath: 'feed.entry.length'
        }
    });

This is the sample code for dataType and dataMap.

var myTable = dataManager.addTable("myTable", {
    remote: {
        read: {
            url: "https://demodata.mescius.io/northwind/api/v1/Orders"
        }
    },
    schema: {
        columns: {
            orderDate: {dataType: "date"},
            requiredDate: {dataType: "date"},
            shippedDate: {dataType: "date"},
            shipVia: {dataMap: {1: "Speedy Express", 2: "United Package", 3: "Federal Shipping"}}
        }
    }
});

This is the sample code for dataPattern.

var myTable = dataManager.addTable("myTable", {
    data: [
        { description: "Mow grass", dueDate: "8/11/2021", priority: "High", assignedTo: "Dad", isFinished: "Yes", isEncouraged: "False", credit: "20,75" },
        { description: "Clean Room", dueDate: "8/9/2021", priority: "Medium", assignedTo: "Daughter", isFinished: "No", isEncouraged: "True", credit: "10,50" },
        { description: "Organize Pantry", dueDate: "8/8/2021", priority: "Low", assignedTo: "Son", isFinished: "Yes", isEncouraged: "True", credit: "10,75" },
        { description: "Prepare BBQ", dueDate: "8/12/2021", priority: "High", assignedTo: "Mom", isFinished: "No", isEncouraged: "False", credit: "30,25" }
    ],
    schema: {
        columns: {
            dueDate: {dataType: "date", dataPattern: "dd/MM/yyyy"},
            isFinished: {dataType: "boolean", dataPattern: "Yes|No"},
            isEncouraged: {dataType: "boolean", dataPattern: "True|False"},
            credit: {dataType: "number", dataPattern: ","}
        }
    }
});

This is the sample code of dataName. the keys of the property columns indicate the field names in the data manager, and the dataName indicates the original data source field name.

var myTable = dataManager.addTable("myTable", {
    remote: {
        read: {
            url: "https://demodata.mescius.io/northwind/api/v1/Orders"
        }
    },
    schema: {
        columns: {
            OrderDate: {dataName: "orderDate"},
            RequiredDate: {dataName: "requiredDate"},
            ShippedDate: {dataName: "shippedDate"},
            ShipVia: {dataName: "shipVia"}
        }
    }
});
The schema contains the following properties: Property Type Description type string Any of 'json', 'csv', 'xml', 'columnJson'. countPath string The data reader uses this to get the data source collection length. dataPath string The data reader uses this to get the data source collection after parse. columns GC.Data.IColumnCollection The columns definitions of the data source table. Its key is column name, and its value is the column information, which contains dataType, dataPattern, dataMap and dataName. The dataType can be a "string", "number", "boolean", "object", "array", "date", "rowOrder" or "formula". It is the actual data type of original value, and useful for a Date because a Date is a string in JSON data and needs be converted. The dataPattern is a string for parsing strings to value, such as the formatter "dd/MM/yyyy" for a date string, true and false value pairs, "Yes|No" for a boolean string, and decimal separator "," for a numeric string. The dataMap is a simple map to display the original value in a more meaningful way. Its key can be a number or string, and its value can be a number, string or Date. The dataName indicates the name of the original data field that be from data source, using this property can map the original field name to the new field name in the data manager. This is the sample code of type, dataPath and countPath. This is the sample code for dataType and dataMap. This is the sample code for dataPattern. This is the sample code of dataName. the keys of the property columns indicate the field names in the data manager, and the dataName indicates the original data source field name.
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ import { Component, NgModule, enableProdMode } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { SpreadSheetsModule } from '@mescius/spread-sheets-angular'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-tablesheet"; import './styles.css'; @Component({ selector: 'app-component', templateUrl: 'src/app.component.html' }) export class AppComponent { hostStyle = { width: '100%', height: '100%', overflow: 'hidden', float: 'left' }; constructor() { } initSpread($event: any) { let spread = $event.spread; spread.suspendPaint(); spread.clearSheets(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var tableName = "Order"; var baseApiUrl = getBaseApiUrl(); var apiUrl = baseApiUrl + "/" + tableName; var dataManager = spread.dataManager(); var myTable = dataManager.addTable("myTable", { remote: { read: { url: apiUrl } }, schema: { columns: { OrderId: {dataName: "Id"}, OrderDate: {dataType: "date"}, RequiredDate: {dataType: "date"}, ShippedDate: {dataType: "date"}, ShipVia: {dataMap: {1: "Speedy Express", 2: "United Package", 3: "Federal Shipping"}} } } }); //init a table sheet var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); sheet.options.allowAddNew = false; //hide new row //bind a view to the table sheet myTable.fetch().then(function () { var style = { formatter: 'MM/dd/yyyy' }; var style2 = { formatter: 'Ship To: {{=CONCAT(@."ShipAddress", ", ", @."ShipCity")}}' }; var view = myTable.addView("myView", [ { value: "OrderId", width: 60 }, { value: "CustomerId",caption:"Customer", width: 100 }, { value: "ShipName", width: 200 }, { value: "OrderDate", width: 120, style: style }, { value: "ShippedDate", width: 120, style: style }, { value: "ShipVia", width: 120 }, { value: "=[@]",caption:"Ship Address",style:style2, width: 350 }, ]); sheet.setDataView(view); }); spread.resumePaint(); } } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; } @NgModule({ imports: [BrowserModule, SpreadSheetsModule], declarations: [AppComponent], exports: [AppComponent], bootstrap: [AppComponent] }) export class AppModule { } enableProdMode(); // Bootstrap application with hash style navigation and global services. platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- Polyfills --> <script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script> <script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script> <!-- SystemJS --> <script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script> <script src="systemjs.config.js"></script> <script> // workaround to load 'rxjs/operators' from the rxjs bundle System.import('rxjs').then(function (m) { System.import('@angular/compiler'); System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators)); System.import('$DEMOROOT$/en/lib/angular/license.ts'); System.import('./src/app.component'); }); </script> </head> <body> <app-component></app-component> </body> </html>
<div class="sample-tutorial"> <gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)"> </gc-spread-sheets> </div>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; margin: 0; }
(function (global) { System.config({ transpiler: 'ts', typescriptOptions: { tsconfig: true }, meta: { 'typescript': { "exports": "ts" }, '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { 'core-js': 'npm:core-js/client/shim.min.js', 'zone': 'npm:zone.js/fesm2015/zone.min.js', 'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js', '@angular/core': 'npm:@angular/core/fesm2022', '@angular/common': 'npm:@angular/common/fesm2022/common.mjs', '@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs', '@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs', '@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs', '@angular/router': 'npm:@angular/router/fesm2022/router.mjs', '@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs', 'jszip': 'npm:jszip/dist/jszip.min.js', 'typescript': 'npm:typescript/lib/typescript.js', 'ts': './plugin.js', 'tslib':'npm:tslib/tslib.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js', '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js', '@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'ts' }, rxjs: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' }, "node_modules/@angular": { defaultExtension: 'mjs' }, "@mescius/spread-sheets-angular": { defaultExtension: 'mjs' }, '@angular/core': { defaultExtension: 'mjs', main: 'core.mjs' } } }); })(this);

Data Source Schema

SpreadJS TableSheet gives the user the ability to provide a data source schema that defines the structure and properties of the TableSheet being added. The user can also use the data source schema to assign a different dataType for columns or a dataPattern/dataMap on how the data would be presented in the TableSheet.

Description
app.jsx
app-func.jsx
app-class.jsx
index.html
styles.css
Copy to CodeMine

The schema contains the following properties:

Property Type Description
type string Any of 'json', 'csv', 'xml', 'columnJson'.
countPath string The data reader uses this to get the data source collection length.
dataPath string The data reader uses this to get the data source collection after parse.
columns GC.Data.IColumnCollection The columns definitions of the data source table. Its key is column name, and its value is the column information, which contains dataType, dataPattern, dataMap and dataName.

The dataType can be a "string", "number", "boolean", "object", "array", "date", "rowOrder" or "formula". It is the actual data type of original value, and useful for a Date because a Date is a string in JSON data and needs be converted.

The dataPattern is a string for parsing strings to value, such as the formatter "dd/MM/yyyy" for a date string, true and false value pairs, "Yes|No" for a boolean string, and decimal separator "," for a numeric string.

The dataMap is a simple map to display the original value in a more meaningful way. Its key can be a number or string, and its value can be a number, string or Date.

The dataName indicates the name of the original data field that be from data source, using this property can map the original field name to the new field name in the data manager.

interface GC.Data.IColumnCollection {
    [key: string]: GC.Data.IColumn;
}
interface GC.Data.IColumn {
    dataName?: string;
    dataType?: "string" | "number" | "boolean" | "object" | "array" | "date" | "rowOrder" | "formula";
    dataPattern?: string;
    dataMap?: any;
}

This is the sample code of type, dataPath and countPath.

    var myTable = dataManager.addTable("myTable", {
        remote: {
            read: {
                url: 'https://services.odata.org/OData/OData.svc/Products/',
                adapter: 'odata'
            }
        },
        schema: {
            type: 'xml',
            dataPath: 'feed.entry',
            countPath: 'feed.entry.length'
        }
    });

This is the sample code for dataType and dataMap.

var myTable = dataManager.addTable("myTable", {
    remote: {
        read: {
            url: "https://demodata.mescius.io/northwind/api/v1/Orders"
        }
    },
    schema: {
        columns: {
            orderDate: {dataType: "date"},
            requiredDate: {dataType: "date"},
            shippedDate: {dataType: "date"},
            shipVia: {dataMap: {1: "Speedy Express", 2: "United Package", 3: "Federal Shipping"}}
        }
    }
});

This is the sample code for dataPattern.

var myTable = dataManager.addTable("myTable", {
    data: [
        { description: "Mow grass", dueDate: "8/11/2021", priority: "High", assignedTo: "Dad", isFinished: "Yes", isEncouraged: "False", credit: "20,75" },
        { description: "Clean Room", dueDate: "8/9/2021", priority: "Medium", assignedTo: "Daughter", isFinished: "No", isEncouraged: "True", credit: "10,50" },
        { description: "Organize Pantry", dueDate: "8/8/2021", priority: "Low", assignedTo: "Son", isFinished: "Yes", isEncouraged: "True", credit: "10,75" },
        { description: "Prepare BBQ", dueDate: "8/12/2021", priority: "High", assignedTo: "Mom", isFinished: "No", isEncouraged: "False", credit: "30,25" }
    ],
    schema: {
        columns: {
            dueDate: {dataType: "date", dataPattern: "dd/MM/yyyy"},
            isFinished: {dataType: "boolean", dataPattern: "Yes|No"},
            isEncouraged: {dataType: "boolean", dataPattern: "True|False"},
            credit: {dataType: "number", dataPattern: ","}
        }
    }
});

This is the sample code of dataName. the keys of the property columns indicate the field names in the data manager, and the dataName indicates the original data source field name.

var myTable = dataManager.addTable("myTable", {
    remote: {
        read: {
            url: "https://demodata.mescius.io/northwind/api/v1/Orders"
        }
    },
    schema: {
        columns: {
            OrderDate: {dataName: "orderDate"},
            RequiredDate: {dataName: "requiredDate"},
            ShippedDate: {dataName: "shippedDate"},
            ShipVia: {dataName: "shipVia"}
        }
    }
});
The schema contains the following properties: Property Type Description type string Any of 'json', 'csv', 'xml', 'columnJson'. countPath string The data reader uses this to get the data source collection length. dataPath string The data reader uses this to get the data source collection after parse. columns GC.Data.IColumnCollection The columns definitions of the data source table. Its key is column name, and its value is the column information, which contains dataType, dataPattern, dataMap and dataName. The dataType can be a "string", "number", "boolean", "object", "array", "date", "rowOrder" or "formula". It is the actual data type of original value, and useful for a Date because a Date is a string in JSON data and needs be converted. The dataPattern is a string for parsing strings to value, such as the formatter "dd/MM/yyyy" for a date string, true and false value pairs, "Yes|No" for a boolean string, and decimal separator "," for a numeric string. The dataMap is a simple map to display the original value in a more meaningful way. Its key can be a number or string, and its value can be a number, string or Date. The dataName indicates the name of the original data field that be from data source, using this property can map the original field name to the new field name in the data manager. This is the sample code of type, dataPath and countPath. This is the sample code for dataType and dataMap. This is the sample code for dataPattern. This is the sample code of dataName. the keys of the property columns indicate the field names in the data manager, and the dataName indicates the original data source field name.
import * as React from 'react'; import * as ReactDOM from 'react-dom'; import './styles.css'; import { AppFunc } from './app-func'; import { App } from './app-class'; // 1. Functional Component sample ReactDOM.render(<AppFunc />, document.getElementById('app')); // 2. Class Component sample // ReactDOM.render(<App />, document.getElementById('app'));
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ import * as React from 'react'; import * as ReactDOM from 'react-dom'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-tablesheet"; import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react'; import './styles.css'; export function AppFunc(){ let spread = null; let initSpread = function(value) { spread = value; spread.suspendPaint(); spread.clearSheets(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var tableName = "Order"; var baseApiUrl = getBaseApiUrl(); var apiUrl = baseApiUrl + "/" + tableName; var dataManager = spread.dataManager(); var myTable = dataManager.addTable("myTable", { remote: { read: { url: apiUrl } }, schema: { columns: { OrderDate: {dataType: "date"}, RequiredDate: {dataType: "date"}, ShippedDate: {dataType: "date"}, ShipVia: {dataMap: {1: "Speedy Express", 2: "United Package", 3: "Federal Shipping"}} } } }); //init a table sheet var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); sheet.options.allowAddNew = false; //hide new row //bind a view to the table sheet myTable.fetch().then(function () { var style = { formatter: 'MM/dd/yyyy' }; var style2 = { formatter: 'Ship To: {{=CONCAT(@."ShipAddress", ", ", @."ShipCity")}}' }; var view = myTable.addView("myView", [ { value: "Id", width: 60 }, { value: "CustomerId",caption:"Customer", width: 100 }, { value: "ShipName", width: 200 }, { value: "OrderDate", width: 120, style: style }, { value: "ShippedDate", width: 120, style: style }, { value: "ShipVia", width: 120 }, { value: "=[@]",caption:"Ship Address",style:style2, width: 350 }, ]); sheet.setDataView(view); }); spread.resumePaint(); } return ( <div class="sample-tutorial"> <div class="sample-spreadsheets"> <SpreadSheets workbookInitialized={spread => initSpread(spread)}> </SpreadSheets> </div> </div> ); } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; }
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ import * as React from 'react'; import * as ReactDOM from 'react-dom'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-tablesheet"; import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react'; import './styles.css'; const Component = React.Component; function _getElementById(id) { return document.getElementById(id); } export class App extends Component { constructor(props) { super(props); } render() { return ( <div class="sample-tutorial"> <div class="sample-spreadsheets"> <SpreadSheets workbookInitialized={spread => this.initSpread(spread)}> </SpreadSheets> </div> </div> ); } initSpread(spread) { spread.suspendPaint(); spread.clearSheets(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var tableName = "Order"; var baseApiUrl = getBaseApiUrl(); var apiUrl = baseApiUrl + "/" + tableName; var dataManager = spread.dataManager(); var myTable = dataManager.addTable("myTable", { remote: { read: { url: apiUrl } }, schema: { columns: { OrderDate: {dataType: "date"}, ShippedDate: {dataType: "date"}, ShipVia: {dataMap: {1: "Speedy Express", 2: "United Package", 3: "Federal Shipping"}} } } }); //init a table sheet var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); sheet.options.allowAddNew = false; //hide new row //bind a view to the table sheet myTable.fetch().then(function () { var style = { formatter: 'MM/dd/yyyy' }; var style2 = { formatter: 'Ship To: {{=CONCAT(@."ShipAddress", ", ", @."ShipCity")}}' }; var view = myTable.addView("myView", [ { value: "Id", width: 60 }, { value: "CustomerId",caption:"Customer", width: 100 }, { value: "ShipName", width: 200 }, { value: "OrderDate", width: 120, style: style }, { value: "ShippedDate", width: 120, style: style }, { value: "ShipVia", width: 120 }, { value: "=[@]",caption:"Ship Address",style:style2, width: 350 }, ]); sheet.setDataView(view); }); spread.resumePaint(); } } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- SystemJS --> <script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('$DEMOROOT$/en/lib/react/license.js').then(function () { System.import('./src/app'); }); </script> </head> <body> <div id="app" style="height: 100%;"></div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; margin: 0; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true, react: true }, meta: { '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js', '@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js', 'react': 'npm:react/umd/react.production.min.js', 'react-dom': 'npm:react-dom/umd/react-dom.production.min.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'jsx' }, "node_modules": { defaultExtension: 'js' }, } }); })(this);

Data Source Schema

SpreadJS TableSheet gives the user the ability to provide a data source schema that defines the structure and properties of the TableSheet being added. The user can also use the data source schema to assign a different dataType for columns or a dataPattern/dataMap on how the data would be presented in the TableSheet.

Description
app.vue
index.html
Copy to CodeMine

The schema contains the following properties:

Property Type Description
type string Any of 'json', 'csv', 'xml', 'columnJson'.
countPath string The data reader uses this to get the data source collection length.
dataPath string The data reader uses this to get the data source collection after parse.
columns GC.Data.IColumnCollection The columns definitions of the data source table. Its key is column name, and its value is the column information, which contains dataType, dataPattern, dataMap and dataName.

The dataType can be a "string", "number", "boolean", "object", "array", "date", "rowOrder" or "formula". It is the actual data type of original value, and useful for a Date because a Date is a string in JSON data and needs be converted.

The dataPattern is a string for parsing strings to value, such as the formatter "dd/MM/yyyy" for a date string, true and false value pairs, "Yes|No" for a boolean string, and decimal separator "," for a numeric string.

The dataMap is a simple map to display the original value in a more meaningful way. Its key can be a number or string, and its value can be a number, string or Date.

The dataName indicates the name of the original data field that be from data source, using this property can map the original field name to the new field name in the data manager.

interface GC.Data.IColumnCollection {
    [key: string]: GC.Data.IColumn;
}
interface GC.Data.IColumn {
    dataName?: string;
    dataType?: "string" | "number" | "boolean" | "object" | "array" | "date" | "rowOrder" | "formula";
    dataPattern?: string;
    dataMap?: any;
}

This is the sample code of type, dataPath and countPath.

    var myTable = dataManager.addTable("myTable", {
        remote: {
            read: {
                url: 'https://services.odata.org/OData/OData.svc/Products/',
                adapter: 'odata'
            }
        },
        schema: {
            type: 'xml',
            dataPath: 'feed.entry',
            countPath: 'feed.entry.length'
        }
    });

This is the sample code for dataType and dataMap.

var myTable = dataManager.addTable("myTable", {
    remote: {
        read: {
            url: "https://demodata.mescius.io/northwind/api/v1/Orders"
        }
    },
    schema: {
        columns: {
            orderDate: {dataType: "date"},
            requiredDate: {dataType: "date"},
            shippedDate: {dataType: "date"},
            shipVia: {dataMap: {1: "Speedy Express", 2: "United Package", 3: "Federal Shipping"}}
        }
    }
});

This is the sample code for dataPattern.

var myTable = dataManager.addTable("myTable", {
    data: [
        { description: "Mow grass", dueDate: "8/11/2021", priority: "High", assignedTo: "Dad", isFinished: "Yes", isEncouraged: "False", credit: "20,75" },
        { description: "Clean Room", dueDate: "8/9/2021", priority: "Medium", assignedTo: "Daughter", isFinished: "No", isEncouraged: "True", credit: "10,50" },
        { description: "Organize Pantry", dueDate: "8/8/2021", priority: "Low", assignedTo: "Son", isFinished: "Yes", isEncouraged: "True", credit: "10,75" },
        { description: "Prepare BBQ", dueDate: "8/12/2021", priority: "High", assignedTo: "Mom", isFinished: "No", isEncouraged: "False", credit: "30,25" }
    ],
    schema: {
        columns: {
            dueDate: {dataType: "date", dataPattern: "dd/MM/yyyy"},
            isFinished: {dataType: "boolean", dataPattern: "Yes|No"},
            isEncouraged: {dataType: "boolean", dataPattern: "True|False"},
            credit: {dataType: "number", dataPattern: ","}
        }
    }
});

This is the sample code of dataName. the keys of the property columns indicate the field names in the data manager, and the dataName indicates the original data source field name.

var myTable = dataManager.addTable("myTable", {
    remote: {
        read: {
            url: "https://demodata.mescius.io/northwind/api/v1/Orders"
        }
    },
    schema: {
        columns: {
            OrderDate: {dataName: "orderDate"},
            RequiredDate: {dataName: "requiredDate"},
            ShippedDate: {dataName: "shippedDate"},
            ShipVia: {dataName: "shipVia"}
        }
    }
});
The schema contains the following properties: Property Type Description type string Any of 'json', 'csv', 'xml', 'columnJson'. countPath string The data reader uses this to get the data source collection length. dataPath string The data reader uses this to get the data source collection after parse. columns GC.Data.IColumnCollection The columns definitions of the data source table. Its key is column name, and its value is the column information, which contains dataType, dataPattern, dataMap and dataName. The dataType can be a "string", "number", "boolean", "object", "array", "date", "rowOrder" or "formula". It is the actual data type of original value, and useful for a Date because a Date is a string in JSON data and needs be converted. The dataPattern is a string for parsing strings to value, such as the formatter "dd/MM/yyyy" for a date string, true and false value pairs, "Yes|No" for a boolean string, and decimal separator "," for a numeric string. The dataMap is a simple map to display the original value in a more meaningful way. Its key can be a number or string, and its value can be a number, string or Date. The dataName indicates the name of the original data field that be from data source, using this property can map the original field name to the new field name in the data manager. This is the sample code of type, dataPath and countPath. This is the sample code for dataType and dataMap. This is the sample code for dataPattern. This is the sample code of dataName. the keys of the property columns indicate the field names in the data manager, and the dataName indicates the original data source field name.
<template> <div class="sample-tutorial"> <gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> </gc-spread-sheets> </div> </template> <script setup> import GC from "@mescius/spread-sheets"; import { ref } from "vue"; import "@mescius/spread-sheets-tablesheet"; import "@mescius/spread-sheets-vue"; const spreadRef = ref(null); function initSpread(spread) { spread.suspendPaint(); spread.clearSheets(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var tableName = "Order"; var baseApiUrl = getBaseApiUrl(); var apiUrl = baseApiUrl + "/" + tableName; var dataManager = spread.dataManager(); var myTable = dataManager.addTable( "myTable", { remote: { read: { url: apiUrl }, }, schema: { columns: { OrderId: { dataName: "Id" }, OrderDate: { dataType: "date" }, RequiredDate: { dataType: "date" }, ShippedDate: { dataType: "date" }, ShipVia: { dataMap: { 1: "Speedy Express", 2: "United Package", 3: "Federal Shipping" } } } } } ); //init a table sheet var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); sheet.options.allowAddNew = false; //hide new row //bind a view to the table sheet myTable.fetch().then(function () { var style = { formatter: 'MM/dd/yyyy' }; var style2 = { formatter: 'Ship To: {{=CONCAT(@."ShipAddress", ", ", @."ShipCity")}}' }; var view = myTable.addView("myView", [ { value: "OrderId", width: 60 }, { value: "CustomerId", caption: "Customer", width: 100 }, { value: "ShipName", width: 200 }, { value: "OrderDate", width: 120, style: style }, { value: "ShippedDate", width: 120, style: style }, { value: "ShipVia", width: 120 }, { value: "=[@]", caption: "Ship Address", style: style2, width: 350 }, ]); sheet.setDataView(view); }); spread.resumePaint(); } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; } </script> <style scoped> #app { height: 100%; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; margin: 0; } </style>
<!DOCTYPE html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <title>SpreadJS VUE</title> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script> <script src="./systemjs.config.js"></script> <script src="./compiler.js" type="module"></script> <script> var System = SystemJS; System.import("./src/app.js"); System.import('$DEMOROOT$/en/lib/vue3/license.js'); </script> </head> <body> <div id="app"></div> </body> </html>
(function (global) { SystemJS.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, packageConfigPaths: [ './node_modules/*/package.json', "./node_modules/@mescius/*/package.json", "./node_modules/@babel/*/package.json", "./node_modules/@vue/*/package.json" ], map: { 'vue': "npm:vue/dist/vue.esm-browser.js", 'tiny-emitter': 'npm:tiny-emitter/index.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', "systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js", '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js' }, meta: { '*.css': { loader: 'systemjs-plugin-css' }, '*.vue': { loader: "../plugin-vue/index.js" } } }); })(this);